#include <iostream>
#include <cmath>

class Cmpx {

private:
  double re;
  double im;

  static const double kPi;
  static const double kEpsilon;

  Cmpx conjugate();
  double modulus2();
  Cmpx reciprocal();

public:
  // constructors
  Cmpx();
  Cmpx(double r);
  Cmpx(double rp, double ip);
  Cmpx(const Cmpx& that);

  // getters
  double real();
  double imag();

  // methods
  Cmpx plus(Cmpx that);
  Cmpx times(Cmpx that);
  Cmpx times(double x);
  Cmpx over(Cmpx that);
  std::string to_string();
};



